#include <eo>
#include <es.h>
#include <iostream>   // cout

#define SIZE 5

// REPRESENTATION 
//-----------------------------------------------------------------------------
// define your individuals
typedef eoReal<double> Indi; 


double fitness_value(const Indi & _indi)
{
  assert( _indi.size() == 2 ); 

  double x = _indi[0]; 
  double y = _indi[1]; 

  double c = (sin(sqrt(x*x+y*y))); 
  return (1 - c*c)/(1+(x*x+y*y)/1000); 
}
