#include <iostream>   // cout

using namespace std;


// implementace selekce 
// prepiste dle vasich predstav 
// 
template <class EOT> class eoMySelect: public eoSelect<EOT> {
        
public:
  
  // redefine 
  virtual void operator()(const eoPop<EOT>& _source, eoPop<EOT>& _dest) {
       
    // discard the individuals with worse fitnesses 
    vector<double> fitnesses; 
    fitnesses.resize( _source.size() );
    
    double mean = 0; 
    for (unsigned i=0; i<fitnesses.size(); i++) {
      fitnesses[i] = _source[i].fitness();
      mean += fitnesses[i]; 
    }
    mean /= fitnesses.size(); 
   
    double total = 0; 
    for (unsigned i=0; i<fitnesses.size(); i++) {
      if (fitnesses[i] < mean) fitnesses[i] = 0.0; 
      total += fitnesses[i]; 
    }

    _dest.resize( _source.size() );
    // do roulette-wheel     
    for (unsigned i=0; i<_dest.size(); i++) 
      _dest[i] = _source[ rng.roulette_wheel(fitnesses,total) ]; 
  }

  

}; 
